#include "coinchange_dp.h"

int getChange_Recursive(int change_total, CoinItem *items, int item_count) {
    int k = 0;
    int min = 99999;
    int value = 0;
    
    if (change_total <= 0)
        return 0;
    
    for (k = 0; k < item_count; k++) {
        if (change_total >= items[k].value) {
            value = getChange_Recursive(change_total - items[k].value, items, item_count) + 1;
            if (value < min) {
                min = value;
            }
        }
        //printf("change_total: %d, k: %d, value: %d,(%d => %d)\n", change_total, k, value,
        //       items[k].value, items[k].selected);
    }
    return min;
}

int getChange_DP(int change_total, CoinItem *items, int item_count) {
    
    int min = 0;
    int *pTotalCount = NULL;
    int **ppValues = NULL;
    
    pTotalCount = (int*)malloc(sizeof(int) * (change_total+1));
    if (pTotalCount == NULL) {
        return min;
    }
    memset(pTotalCount, 0, sizeof(int) * item_count);
    
    ppValues = (int**)malloc(sizeof(int *) * (change_total+1));
    if (ppValues == NULL) {
        free(pTotalCount);
        return min;
    }
    for( int j = 0; j <= change_total; j++) {
        ppValues[j] = (int*)malloc(sizeof(int) * (item_count + 1));
        if (ppValues[j] != NULL) {
            memset(ppValues[j], 0, sizeof(int) * (item_count + 1));
        }
        else {
            return min;
        }
    }
    
    for( int i = 1; i <= change_total; i++) {
        min = 9999;
        for (int j = 0; j < item_count; j++) {
            if (items[j].value <= i) {
                if (min > pTotalCount[i - items[j].value] + 1) {
                    min = pTotalCount[i - items[j].value] + 1;
                    for(int k = 0; k < item_count; k++) {
                        ppValues[i][k] = ppValues[i - items[j].value][k];
                    }
                    ppValues[i][j]++;
                }
            }
        }
        pTotalCount[i] = min;
    }
    
    min = pTotalCount[change_total];

    for( int j = 0; j < item_count; j++) {
        items[j].selected = ppValues[change_total][j];
    }
    
    for( int j = 0; j <= change_total; j++) {
        free( ppValues[j] );
    }
    free(ppValues);
    free(pTotalCount);
    
    return min;
}

void inputItems(CoinItem *items, int item_count) {
    int i = 0;
    for (i = 0; i < item_count; i++) {
        printf("%d °   Է ּ (, 100)\n", i + 1);
        scanf("%d", &items[i].value);
        
        items[i].selected = 0;
    }
}

void printResultDP(CoinItem *items, int item_count, int coin_count) {
    int i = 0;
    printf("()\t( )\n");
    for (i = 0; i < item_count; i++) {
        printf("%d\t%d\n", items[i].value, items[i].selected);
    }
    printf(" ü  : %d\n", coin_count);
}


